package ms.vmedinap.tfg.dbcommons.models.entity;

import org.springframework.lang.Nullable;

import javax.persistence.*;
import java.io.Serializable;

/**
 * Trabajo: TFG
 * Título: Seguridad adicional frente a ciber ataques “Man-In-The-Middle”
 * Carrera: Grado en Ingeniería Informática
 * Área: Ingeniería del Software
 * Curso: 2021-2022
 *
 * @author Víctor Medina Pérez
 */
@Entity
@Table(name = "tarjetas", schema = "main")
public class Tarjeta implements Serializable {

    private static final long serialVersionUID = 2L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "tarjeta_id")
    private Long id;

    @Column(length = 50)
    private String titular;

    @Column(length = 16)
    private String pan;

    @Column(length = 2)
    private String expiry_month;

    @Column(length = 4)
    private String expiry_year;

    public Tarjeta(Long id, String titular, String pan, String expiry_month, String expiry_year) {
        this.id = id;
        this.titular = titular;
        this.pan = pan;
        this.expiry_month = expiry_month;
        this.expiry_year = expiry_year;
    }

    public Tarjeta() {
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getTitular() {
        return titular;
    }

    public void setTitular(String titular) {
        this.titular = titular;
    }

    public String getPan() {
        return pan;
    }

    public void setPan(String pan) {
        this.pan = pan;
    }

    public String getExpiry_month() {
        return expiry_month;
    }

    public void setExpiry_month(String expiry_month) {
        this.expiry_month = expiry_month;
    }

    public String getExpiry_year() {
        return expiry_year;
    }

    public void setExpiry_year(String expiry_year) {
        this.expiry_year = expiry_year;
    }

}
