package ms.vmedinap.tfg.oauthserver.feign;

import ms.vmedinap.tfg.dbcommons.models.entity.Usuario;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;

/**
 * Trabajo: TFG
 * Título: Seguridad adicional frente a ciber ataques “Man-In-The-Middle”
 * Carrera: Grado en Ingeniería Informática
 * Área: Ingeniería del Software
 * Curso: 2021-2022
 *
 * @author Víctor Medina Pérez
 */
@FeignClient(name = "jwe-generator")
public interface JweGeneratorClient {

    @GetMapping("/usuarios/search/findByEmail")
    public Usuario findByEmail(@RequestParam(name = "email") String email);

    @GetMapping("/jweInfoByEmail")
    public ResponseEntity<String> getJweInfoByEmail(@RequestParam(name = "email") String email);

}
