package ms.vmedinap.tfg.paymentservice.mastercard.service.impl;

import ms.vmedinap.tfg.paymentservice.mastercard.models.MockedCardCreation;
import ms.vmedinap.tfg.paymentservice.mastercard.models.MockedDonorCreation;
import ms.vmedinap.tfg.paymentservice.mastercard.models.MockedOneTimeTransaction;
import ms.vmedinap.tfg.paymentservice.mastercard.service.MockedService;
import org.springframework.stereotype.Service;

import java.security.SecureRandom;

/**
 * Trabajo: TFG
 * Título: Seguridad adicional frente a ciber ataques “Man-In-The-Middle”
 * Carrera: Grado en Ingeniería Informática
 * Área: Ingeniería del Software
 * Curso: 2021-2022
 *
 * @author Víctor Medina Pérez
 */
@Service
public class MockedServiceImpl implements MockedService {

    private static SecureRandom secureRandom;


    public MockedServiceImpl() {
        if (secureRandom == null)
            secureRandom = new SecureRandom();
    }

    @Override
    public MockedDonorCreation mockedDonorCreation(String userName) {
        int randomPrefixId = secureRandom.nextInt(99);
        int randomSuffixId = secureRandom.nextInt(1000);
        return new MockedDonorCreation(randomPrefixId + "2ce9ff-fa5f-4e9f-8151-c73fa2008" + randomSuffixId,
                userName);
    }

    @Override
    public MockedCardCreation mockedCardCreation(String suffix) {
        int randomPrefixId = secureRandom.nextInt(99);
        int randomSuffixId = secureRandom.nextInt(1000);
        return new MockedCardCreation(randomPrefixId + "ee3d81-18d4-409a-8330-73db083f"
                + randomSuffixId, suffix);
    }

    @Override
    public MockedOneTimeTransaction mockedOneTimeTransaction() {
        int randomPrefixId = secureRandom.nextInt(99);
        int randomSuffixId = secureRandom.nextInt(1000);
        return new MockedOneTimeTransaction(randomPrefixId + "3c4ef1-d449-4d79-a456-fb6ba3f" + randomSuffixId,
                "SUCCESS",
                "Transaction APPROVED");
    }
}
