package ms.vmedinap.tfg.paymentservice.models.entities;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * Trabajo: TFG
 * Título: Seguridad adicional frente a ciber ataques “Man-In-The-Middle”
 * Carrera: Grado en Ingeniería Informática
 * Área: Ingeniería del Software
 * Curso: 2021-2022
 *
 * @author Víctor Medina Pérez
 */
@Entity
@Table(name = "cards", schema = "payments")
public class Card implements Serializable {

    private static final long serialVersionUID = 0L;

    @Id
    @Column(name = "card_id", length = 36)
    private String id;

    @Column(length = 36)
    private String donor_id;

    @Column(name = "primaryaccountsuffix")
    private String primaryAccountSuffix;

    public Card(String id, String donor_id, String primaryAccountSuffix) {
        this.id = id;
        this.donor_id = donor_id;
        this.primaryAccountSuffix = primaryAccountSuffix;
    }

    public Card() {
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getPrimaryAccountSuffix() {
        return primaryAccountSuffix;
    }

    public void setPrimaryAccountSuffix(String primaryAccountSuffix) {
        this.primaryAccountSuffix = primaryAccountSuffix;
    }

    public String getDonor_id() {
        return donor_id;
    }

    public void setDonor_id(String donor_id) {
        this.donor_id = donor_id;
    }
}
