package ms.vmedinap.tfg.paymentservice.models.entities;

import javax.persistence.*;
import java.io.Serializable;
import java.util.List;

/**
 * Trabajo: TFG
 * Título: Seguridad adicional frente a ciber ataques “Man-In-The-Middle”
 * Carrera: Grado en Ingeniería Informática
 * Área: Ingeniería del Software
 * Curso: 2021-2022
 *
 * @author Víctor Medina Pérez
 */
@Entity
@Table(name = "donors", schema = "payments")
public class Donor implements Serializable {

    private static final long serialVersionUID = 0L;

    @Id
    @Column(name = "donor_id", length = 36)
    private String id;

    @Column(length = 12, unique = true)
    private String usuario_id;

    @Column(length = 60, unique = true)
    private String username;

    @Column(length = 30)
    private String usertype;

    @Column(length = 60, unique = true)
    private String email;

    @Column(length = 5)
    private String locale;

    @Column(length = 30)
    private String name;

    @Column(name = "acceptedconsents")
    private boolean acceptedConsent;

    @OneToMany(cascade = CascadeType.ALL, orphanRemoval = true)
    @JoinColumn(name = "donor_id")
    private List<Card> cards;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getUsuario_id() {
        return usuario_id;
    }

    public void setUsuario_id(String usuario_id) {
        this.usuario_id = usuario_id;
    }

    public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username;
    }

    public String getUsertype() {
        return usertype;
    }

    public void setUsertype(String usertype) {
        this.usertype = usertype;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getLocale() {
        return locale;
    }

    public void setLocale(String locale) {
        this.locale = locale;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public boolean isAcceptedConsent() {
        return acceptedConsent;
    }

    public void setAcceptedConsent(boolean acceptedConsent) {
        this.acceptedConsent = acceptedConsent;
    }

    public List<Card> getCards() {
        return cards;
    }

    public void setCards(List<Card> cards) {
        this.cards = cards;
    }
}
