package ms.vmedinap.tfg.paymentservice.models.repository;

import ms.vmedinap.tfg.paymentservice.models.entities.Card;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.stereotype.Repository;

import java.util.Optional;

/**
 * Trabajo: TFG
 * Título: Seguridad adicional frente a ciber ataques “Man-In-The-Middle”
 * Carrera: Grado en Ingeniería Informática
 * Área: Ingeniería del Software
 * Curso: 2021-2022
 *
 * @author Víctor Medina Pérez
 */
@Repository
public interface CardRepository extends CrudRepository<Card, String> {
    @Query(value = "SELECT * FROM payments.cards c WHERE c.donor_id = ?1 AND c.primaryaccountsuffix = ?2",
            nativeQuery = true)
    Optional<Card> findByDonorId(String donorId, String suffix);
}
