package ms.vmedinap.tfg.paymentservice.models.repository;

import ms.vmedinap.tfg.paymentservice.models.entities.Donor;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.stereotype.Repository;

import java.util.Optional;

/**
 * Trabajo: TFG
 * Título: Seguridad adicional frente a ciber ataques “Man-In-The-Middle”
 * Carrera: Grado en Ingeniería Informática
 * Área: Ingeniería del Software
 * Curso: 2021-2022
 *
 * @author Víctor Medina Pérez
 */
@Repository
public interface DonorRepository extends CrudRepository<Donor, String> {

    @Query(value = "SELECT * FROM payments.donors d WHERE d.usuario_id = ?1", nativeQuery = true)
    Optional<Donor> findByUsuarioId(String s);

}
